import { CheckboxSOP } from '../../libappsop/checkboxsop';
import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogDummy } from '../dialogs/dialog.dummy';

export class FormPurchasingPlanDetails extends FormSOP {
  public static readonly title = 'Purchasing Plan Details';
  public listPurchasingPlanDetails = new ListPurchasingPlanDetails();
  public cbFilterByPurchasingPlan = new CheckboxSOP('CheckboxToggleButton');

  public constructor() {
    super('FormPurchasingPlan');
  }
}

export class ListPurchasingPlanDetails extends ListSOP<DialogDummy, ListPurchasingPlanDetailsColumn> {
  public static readonly title = 'Purchasing Plan Details';

  public constructor() {
    super('ListNewSupply', new DialogDummy());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { StockingPoint: '', Product: '', Unit: '', Start: '', Operation: '' };
  }
}

export interface ListPurchasingPlanDetailsColumn {
  StockingPoint?: string;
  Product?: string;
  Unit?: string;
  Routing?: string;
  Step?: string;
  Operation?: string;
  Start?: string;
  Quantity?: string;
}

// Although form (and not dialog), we create the interface so that spec script can use for step description (e.g calling StepDialog related method to use in "it")
export interface FormPurchasingPlanDetailsFields {
  ToggleFilterByPurchasingPlan: boolean;
}
